Unit ash0e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ash0e(var A :Array of Extended; var B :Array of Extended;
                var X :Array of Extended; var S :Array of Extended;
                N :Integer; P :Integer);

implementation

procedure ash0e(var A :Array of Extended; var B :Array of Extended;
                var X :Array of Extended; var S :Array of Extended;
                N :Integer; P :Integer);
var
J,J1,I,I1,K,N1 :Integer;
Z,F :Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11;
begin
if ( P <> 1 ) 
 then goto _7;
S[0] := 1.e0/A[0+0*N];
J1 := 1;
J := 2;
goto _4;
_1:
J1 := J;
J := J+1;
for I:=2 to J1 do
 begin
  I1 := I-1;
  Z := A[(I-1)+(J-1)*N];
  for K:=1 to I1 do
   begin
_2:
    Z := Z-A[(K-1)+(J-1)*N]*A[(K-1)+(I-1)*N];
   end;
_3:
  A[(I-1)+(J-1)*N] := Z;
 end;
_4:
Z := A[(J-1)+(J-1)*N];
for K:=1 to J1 do
 begin
  F := A[(K-1)+(J-1)*N];
_5:
  Z := Z-F*S[K-1]*F;
 end;
S[J-1] := 1.e0/Z;
for I:=1 to J1 do
 begin
_6:
  A[(I-1)+(J-1)*N] := A[(I-1)+(J-1)*N]*S[I-1];
 end;
if ( J <> N ) 
 then goto _1;
_7:
X[0] := B[0];
for I:=2 to N do
 begin
  Z := B[I-1];
  I1 := I-1;
  for K:=1 to I1 do
   begin
_8:
    Z := Z-A[(K-1)+(I-1)*N]*X[K-1];
   end;
_9:
  X[I-1] := Z;
 end;
N1 := N+1;
for J:=1 to N do
 begin
  I := N1-J;
  Z := X[I-1]*S[I-1];
  I1 := I+1;
  if ( I1 > N )
   then goto _11;
  for K:=I1 to N do
   begin
_10:
    Z := Z-A[(I-1)+(K-1)*N]*X[K-1];
   end;
_11:
  X[I-1] := Z;
 end;
end;

end.
